<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\EmissaoAutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\DTO;

class Cmp05300AFPorFilial extends \Zeedhi\Framework\Controller\Report {
    protected $qr2Strategy;
    protected $stNomeRel;
    protected $environment;
    protected $filialService;
    
    public function __construct($reportService, $qr2Strategy, $environment, $filialService) {
        $this->reportService    = $reportService;
        $this->qr2Strategy      = $qr2Strategy;
        $this->environment      = $environment;
        $this->filialService    = $filialService;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);

        $row['CDREGIAO1'] = $row['CDREGIAO'];
        $row['CDREGIAO2'] = $row['CDREGIAO'];

        if (empty($row['DTENTREINI']) && empty($row['DTENTREFIN'])) {
            $row['DTENTREINI'] = "30/12/1899";
            $row['DTENTREFIN'] = "30/12/1899";
        } else {
            $dataInicial = explode(" ", $row['DTENTREINI']);
            $dataFinal   = explode(" ", $row['DTENTREFIN']);

            $row['DTENTREINI'] = $dataInicial[0];
            $row['DTENTREFIN'] = $dataFinal[0];
        }
        
        $cdOperador = $this->environment->getCdOperador();
        
        if($row["FILLANC"] == "T") {
            $newFilial = $this->filialService->retornaListaDeFiliais($cdOperador);
            if(is_array($newFilial)) {
                    $str = "_";
                    foreach($newFilial as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $newFilial = $str;
                    $row["FILLANC"] = $newFilial;
                }
        }
        
        if($row["CDFILDEST"] == "T") {
            $newFilial = $this->filialService->retornaListaDeFiliais($cdOperador);
            if(is_array($newFilial)) {
                    $str = "_";
                    foreach($newFilial as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $newFilial = $str;
                    $row["CDFILDEST"] = $newFilial;
                }
        }
        
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array (
            'strategy' => $row['STRATEGY'],
            'parameterMapping' =>
                array (                
                    'CDREGIAO'      => 'L_CDREGIAO',
                    'CDREGIAO1'     => 'L_CDREGIAO1',
                    'CDREGIAO2'     => 'L_CDREGIAO2',
                    'FILLANC'       => 'L_CDFILLANC',
                    'CDFILDEST'     => 'L_CDFILDEST',
                    'OPERADOR'      => 'L_CDOPERADOR',
                    'IMPOSTO'       => 'L_CDIMPOSTO',
                    'CDFORNECED'    => 'P_CDFORNECEDOR',
                    'ORDENA'        => 'P_ORDENA',
                    'MODO'          => 'P_MODO',
                    'NRAUTOFORNINI' => 'P_NRAUTOFORNINI',
                    'NRAUTOFORNFIN' => 'P_NRAUTOFORNFIN',
                    'DTENTREINI'    => 'P_DTENTREINI',
                    'DTENTREFIN'    => 'P_DTENTREFIN',
                    'IMPRIME'       => 'P_IMPRIME',
                    'AFORDT'        => 'P_AFORDT',
                    'IMPRIMEOBS'    => 'P_IMPRIMEOBS',
                    'CDFILIPROC'    => 'P_CDFILIPROC'
                ),
            );
    }
}
